// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Dock;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDockBin")]
    pub struct DockBin(Object<ffi::DzlDockBin, ffi::DzlDockBinClass>) @extends gtk::Container, gtk::Widget, @implements gtk::Buildable, Dock;

    match fn {
        type_ => || ffi::dzl_dock_bin_get_type(),
    }
}

impl DockBin {
    pub const NONE: Option<&'static DockBin> = None;

    #[doc(alias = "dzl_dock_bin_new")]
    pub fn new() -> DockBin {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_dock_bin_new()).unsafe_cast() }
    }
}

impl Default for DockBin {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::DockBin>> Sealed for T {}
}

pub trait DockBinExt: IsA<DockBin> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_dock_bin_get_bottom_edge")]
    #[doc(alias = "get_bottom_edge")]
    fn bottom_edge(&self) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_dock_bin_get_bottom_edge(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_bin_get_center_widget")]
    #[doc(alias = "get_center_widget")]
    fn center_widget(&self) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_dock_bin_get_center_widget(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_bin_get_left_edge")]
    #[doc(alias = "get_left_edge")]
    fn left_edge(&self) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_dock_bin_get_left_edge(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_bin_get_right_edge")]
    #[doc(alias = "get_right_edge")]
    fn right_edge(&self) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_dock_bin_get_right_edge(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_bin_get_top_edge")]
    #[doc(alias = "get_top_edge")]
    fn top_edge(&self) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_dock_bin_get_top_edge(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "bottom-visible")]
    fn is_bottom_visible(&self) -> bool {
        ObjectExt::property(self.as_ref(), "bottom-visible")
    }

    #[doc(alias = "bottom-visible")]
    fn set_bottom_visible(&self, bottom_visible: bool) {
        ObjectExt::set_property(self.as_ref(), "bottom-visible", bottom_visible)
    }

    #[doc(alias = "left-visible")]
    fn is_left_visible(&self) -> bool {
        ObjectExt::property(self.as_ref(), "left-visible")
    }

    #[doc(alias = "left-visible")]
    fn set_left_visible(&self, left_visible: bool) {
        ObjectExt::set_property(self.as_ref(), "left-visible", left_visible)
    }

    #[doc(alias = "right-visible")]
    fn is_right_visible(&self) -> bool {
        ObjectExt::property(self.as_ref(), "right-visible")
    }

    #[doc(alias = "right-visible")]
    fn set_right_visible(&self, right_visible: bool) {
        ObjectExt::set_property(self.as_ref(), "right-visible", right_visible)
    }

    #[doc(alias = "top-visible")]
    fn is_top_visible(&self) -> bool {
        ObjectExt::property(self.as_ref(), "top-visible")
    }

    #[doc(alias = "top-visible")]
    fn set_top_visible(&self, top_visible: bool) {
        ObjectExt::set_property(self.as_ref(), "top-visible", top_visible)
    }

    #[doc(alias = "bottom-visible")]
    fn connect_bottom_visible_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_bottom_visible_trampoline<
            P: IsA<DockBin>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockBin,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockBin::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::bottom-visible\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_bottom_visible_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "left-visible")]
    fn connect_left_visible_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_left_visible_trampoline<
            P: IsA<DockBin>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockBin,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockBin::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::left-visible\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_left_visible_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "right-visible")]
    fn connect_right_visible_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_right_visible_trampoline<
            P: IsA<DockBin>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockBin,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockBin::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::right-visible\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_right_visible_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "top-visible")]
    fn connect_top_visible_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_top_visible_trampoline<P: IsA<DockBin>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlDockBin,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockBin::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::top-visible\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_top_visible_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<DockBin>> DockBinExt for O {}

impl fmt::Display for DockBin {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DockBin")
    }
}
